
UPDATE TAR_UI_PARAMS SET 
    DELPHI_IMPLEMENT = 'unit board;
implementation
procedure board_ValidateControls(spObject: TSPObject);
begin
end;
procedure board_GetScript(spObject: TSPObject; var strValue: string);
begin
  strValue := Copy(spObject.Values,1,Pos('';'',spObject.Values)-1);
  if strValue = ''-1'' then strValue := '''';
end;
procedure board_BeforeRender(spObject: TSPObject; pHplder: TWinControl);
var
  pDS: TDataSource;
begin
  spObject.releaseControls;
  spObject.addControl(''lookupcb'', TRxDBLookupCombo.Create(spObject));
  TRxDBLookupCombo(spObject.getControl(''lookupcb'')).DropDownWidth := 200;
  pDS := spObject.getDataSource(''BOARDS'', ''select m.NAME as TYPE_HRANA, m.ID_SERVICE as ID_TYPE_HRANA from   MEALS m where  m.IS_BOARD = 1 and m.ID_HOTEL = @ID_HOTEL order by m.WEIGHT_TAG asc'');
  if nil <> pDS then begin
    TRxDBLookupCombo(spObject.getControl(''lookupcb'')).LookupSource := pDS;
    TRxDBLookupCombo(spObject.getControl(''lookupcb'')).LookupField := ''ID_TYPE_HRANA'';
    TRxDBLookupCombo(spObject.getControl(''lookupcb'')).LookupDisplay := ''TYPE_HRANA'';
    TRxDBLookupCombo(spObject.getControl(''lookupcb'')).OnKeyDown := board_KeyDown;
    TRxDBLookupCombo(spObject.getControl(''lookupcb'')).EmptyValue := '''';
    TRxDBLookupCombo(spObject.getControl(''lookupcb'')).DisplayEmpty := '''';
  end;
  TRxDBLookupCombo(spObject.getControl(''lookupcb'')).Value := Copy(spObject.Values,1,Pos('';'',spObject.Values)-1);
end;
procedure board_RenderControl(strControlName: string; pControl: TControl; pHolder: TWinControl; pRectHolder: TRectHolder; var bDone: Boolean);
begin
  pControl.Top := pRectHolder.getTop - 1;
  pControl.Left := pRectHolder.getLeft - 1;
  pControl.Width := pRectHolder.getRight - pRectHolder.getLeft + 2;
  pHolder.InsertControl(pControl);
  pControl.OnExit := spExitControls;
  pControl.SetFocus;
  bDone := true;
end;
procedure board_SynchronValues(spObject: TSPObject);
begin
  try
    spObject.Values := TRxDBLookupCombo(spObject.getControl(''lookupcb'')).Value + '';'' + TRxDBLookupCombo(spObject.getControl(''lookupcb'')).Text;
  except
  end;
end;
procedure board_SetKChar(spObject: TSPObject; Ch: Char);
begin
  if TRxDBLookupCombo(spObject.getControl(''lookupcb'')).LookupSource.DataSet.Locate(TRxDBLookupCombo(spObject.getControl(''lookupcb'')).LookupDisplay,UpperCase(Ch),[loCaseInsensitive, loPartialKey]) then
    TRxDBLookupCombo(spObject.getControl(''lookupcb'')).Value := TRxDBLookupCombo(spObject.getControl(''lookupcb'')).LookupSource.DataSet.FieldByName(TRxDBLookupCombo(spObject.getControl(''lookupcb'')).LookupField).AsString;
  TRxDBLookupCombo(spObject.getControl(''lookupcb'')).DropDown;
end;
procedure board_KeyDown(Sender: TObject; var Key: Word;
  Shift: TShiftState);
begin
  if not TRxDBLookupCombo(Sender).IsDropDown then
    if (Shift = []) and (Key = 13) then
      if TControl(Sender).Owner <> nil then
        TControl(Sender).Parent.SetFocus
      else
    else if (Shift = []) and (Key = 27) then
      if TControl(Sender).Owner <> nil then begin
        TSPObject(TControl(Sender).Owner).CancelGetValues := True;
        TControl(Sender).Parent.SetFocus;
      end;
end;
procedure board_GetVisibleData(spObject: TSPObject; KeyValue: String; var strValues: String);
begin
  strValues := Copy(KeyValue,Pos('';'',KeyValue)+1,Length(KeyValue));
end;

function boardexpandGUID(spObject: TSPObject): String;
var key: String;
begin
  key := TRxDBLookupCombo(spObject.getControl(''lookupcb'')).Value;
  if StrToIntDef(key,0) > 0 then
    key := ''@{BOARDS.'' + key + '';'' + TRxDBLookupCombo(spObject.getControl(''lookupcb'')).Text + ''}'';
  Result := key;
end;

procedure boardGetInterfaceValuesUID(spObject: TSPObject; var strValues: string);
begin
  try
    strValues := boardexpandGUID(spObject) + '';'' + TRxDBLookupCombo(spObject.getControl(''lookupcb'')).Text;
  except
  end;
end;

procedure boardGetScriptUID(spObject: TSPObject; var strValues: string);
begin
  try
    strValues := boardexpandGUID(spObject);
  except
  end;
end;


end.'
WHERE (INTERNAL_PARAM_NAME = 'board');

update SYSTEM_INFO_UPDATE su
set    su.PRODUCT_VERSION = 'EVO-2011'
where  su.PATCH_VERSION in ('0', '1');

update SYSTEM_INFO_UPDATE su
set    su.PRODUCT_VERSION = 'EVOLUTION'
where  su.PRODUCT_VERSION is null;

