update TAR_HEAD T
set    t.EXPLICIT_TAX_POLICY = (select tp.ID_TAX_POLICY
                                from   TAX_POLICY tp
                                where  tp.ID_TAX_POLICY = t.EXPLICIT_TAX_POLICY);

update SALE_TAXES st
set    st.TAX_PERCENT = null
where  st.IS_PERCENT_TAX = 0;


delete from  HK_PLAN_ITEM hki
where  not exists (select h.ID_HOTEL
                   from   HOTEL h
                   where  h.ID_HOTEL = hki.ID_HOTEL);

delete from  PAYMENT_TYPE pt
where  not exists (select h.ID_HOTEL
                   from   HOTEL h
                   where  h.ID_HOTEL = pt.ID_HOTEL);

delete from  AGENT_AGES aa
where  not exists (select a.ID_AGENT
                   from   agent a
                   where  a.ID_AGENT = aa.ID_AGENT);


commit work;

