delete
from   REPORT R
where  R.IDENT = 'quarter_statistic_fr3';


update DEPOSIT d
set    d.ID_BILLING_SERVICE = (select dl.ID_SERVICE
                               from   PAYMENT_HEAD p
                                      join DOC_HEAD$INT dh on dh.ID_DOC_HEAD = p.ID_DOC_HEAD
                                      join DOC_LINE dl on dl.ID_DOC_HEAD = dh.ID_DOC_HEAD
                               where  p.ID_PAYMENT_HEAD = d.ID_PAYMENT_HEAD
                                      and dh.IS_ANUL = 0
                                      and dh.FOR_DEPOSIT = 1)
where  d.ID_BILLING_SERVICE is null;

commit work;

update PAYMENT_TYPE PT
set    pt.IS_USE = 1
where  pt.IS_USE = 0
       and
       exists (select dt.ID_DOC_TYPE
               from   doc_type dt
                      join doc_type_pay dtp on dtp.ID_DOC_TYPE = dt.ID_DOC_TYPE
               where  dt.IS_ARCHIVE = 0
                      and dtp.ID_PAYMENT_TYPE = pt.ID_PAYMENT_TYPE);

commit work;

update PROFILE p
set    p.MERGE_NAME = cast(p.PROFILE_NAME as varchar(100) character set WIN1250),
       p.MERGE_IDENT_NUM = (select cast(pd.EGN as varchar(30) character set WIN1250)
                            from   PROFILE_PERSON pp
                                   join PERSON_DATA pd on pd.ID_PERSON_DATA = pp.ID_PERSON_DATA
                            where  pp.ID_PROFILE = p.ID_PROFILE),
       p.MERGE_IDENT_NUM_ALT = (select cast(pd.PASS_NUM as varchar(30) character set WIN1250)
                                from   PROFILE_PERSON pp
                                       join PERSON_DATA pd on pd.ID_PERSON_DATA = pp.ID_PERSON_DATA
                                where  pp.ID_PROFILE = p.ID_PROFILE)
where  exists (select * from SYSTEM_INFO_GET ('DATABASE CHARSET') si where si.info_value = 'WIN1250')
       and p.PROFILE_TYPE in ('PERSON', 'AGENT');

commit work;

update PROFILE p
set    p.MERGE_NAME = cast(p.PROFILE_NAME as varchar(100) character set WIN1251),
       p.MERGE_IDENT_NUM = (select cast(pd.EGN as varchar(30) character set WIN1251)
                            from   PROFILE_PERSON pp
                                   join PERSON_DATA pd on pd.ID_PERSON_DATA = pp.ID_PERSON_DATA
                            where  pp.ID_PROFILE = p.ID_PROFILE),
       p.MERGE_IDENT_NUM_ALT = (select cast(pd.PASS_NUM as varchar(30) character set WIN1251)
                                from   PROFILE_PERSON pp
                                       join PERSON_DATA pd on pd.ID_PERSON_DATA = pp.ID_PERSON_DATA
                                where  pp.ID_PROFILE = p.ID_PROFILE)
where  exists (select * from SYSTEM_INFO_GET ('DATABASE CHARSET') si where si.info_value = 'WIN1251')
       and p.PROFILE_TYPE in ('PERSON', 'AGENT');

commit work;

update PROFILE p
set    p.MERGE_NAME = cast(p.PROFILE_NAME as varchar(100) character set WIN1252),
       p.MERGE_IDENT_NUM = (select cast(pd.EGN as varchar(30) character set WIN1252)
                            from   PROFILE_PERSON pp
                                   join PERSON_DATA pd on pd.ID_PERSON_DATA = pp.ID_PERSON_DATA
                            where  pp.ID_PROFILE = p.ID_PROFILE),
       p.MERGE_IDENT_NUM_ALT = (select cast(pd.PASS_NUM as varchar(30) character set WIN1252)
                                from   PROFILE_PERSON pp
                                       join PERSON_DATA pd on pd.ID_PERSON_DATA = pp.ID_PERSON_DATA
                                where  pp.ID_PROFILE = p.ID_PROFILE)
where  exists (select * from SYSTEM_INFO_GET ('DATABASE CHARSET') si where si.info_value in ('WIN1252', 'NONE'))
       and p.PROFILE_TYPE in ('PERSON', 'AGENT');

commit work;


