
UPDATE COUNTRY
SET    COUNTRY_CODE = 'AG',
       ISO_ALPHA_3 = 'ATG'
WHERE  COUNTRY_CODE = 'AI';

commit work;

update AR_PAYMENT_TYPE t
set    t.PAYMENT_TYPE = (select pt.PAYMENT_TYPE
                         from   PAYMENT_TYPE pt
                         where  pt.ID_PAYMENT_TYPE = t.ID_AR_PAYMENT_TYPE),
       t.IS_USE = 1;

update AR_PAYMENT ap
set ap.ACCOUNT_NAME = (select pa.ACCOUNT_NAME
                       from   AR_PAYMENT_ACCOUNT pa
                       where  pa.ID_AR_PAYMENT_ACCOUNT = ap.ID_AR_PAYMENT_ACCOUNT),
    ap.REST_PAYMENT = (select ad.REST_PAYMENT
                       from   AR_PAYMENT_ADD ad
                       where  ad.ID_AR_PAYMENT = ap.ID_AR_PAYMENT),
    ap.PAYMENT_STATUS = (select ad.PAYMENT_STATUS
                       from   AR_PAYMENT_ADD ad
                       where  ad.ID_AR_PAYMENT = ap.ID_AR_PAYMENT),
    ap.ID_AR_PAYMENT_TYPE = (select first 1 pt2.ID_AR_PAYMENT_TYPE
                               from   AR_PAYMENT_TYPE pt
                                      join AR_PAYMENT_TYPE pt2 on pt2.PAYMENT_TYPE = pt.PAYMENT_TYPE
                               where  pt.ID_AR_PAYMENT_TYPE = ap.ID_AR_PAYMENT_TYPE
                               order by pt2.ID_AR_PAYMENT_TYPE asc);

update AR_OWING a
set a.REST_OWING = (select ad.REST_OWING
                       from   AR_OWING_ADD ad
                       where  ad.ID_AR_OWING = a.ID_AR_OWING),
    a.OWING_STATUS = (select ad.OWING_STATUS
                       from   AR_OWING_ADD ad
                       where  ad.ID_AR_OWING = a.ID_AR_OWING);

update AR_OWING_PAYMENT_POST op
set    op.ID_PROFILE = (select o.ID_PROFILE
                        from   AR_OWING o
                        where  o.ID_AR_OWING = op.ID_AR_OWING);

delete from AR_PAYMENT_TYPE p
where not exists (select ap.ID_AR_PAYMENT
                  from   AR_PAYMENT ap
                  where  ap.ID_AR_PAYMENT_TYPE = p.ID_AR_PAYMENT_TYPE);

commit work;

update ACCOUNT_POST ap
set    ap.DOC_SELECTED = -1,
       ap.ac = '10',
       ap.IS_ANUL = 1
where  ap.ID_BASE_DOC > 0
       and ap.QTY_POST = 0
       and ap.IN_DOC_QTY = 0
       and ap.ac = '00';

commit work;

