UPDATE TAR_UI_PARAMS tp
SET    tp.DELPHI_IMPLEMENT =
'unit price_all;
implementation
procedure price_all_ValidateControls(spObject: TSPObject);
var Txt: String;
begin
  try
    Txt := trim(TEdit(spObject.getControl(''num'')).Text);
    if Length(Txt) = 0 then exit;
    if (Length(Txt) > 0) and (Txt[1] = ''='') then begin
      Delete(Txt,1,1);
      if (Length(Txt) > 0) and (Txt[1] = ''-'') then
        raise Exception.Create(''Invalid value'');
      StrToFloat(Txt);
      exit;
    end;
    if (Length(Txt) > 0) and (Txt[Length(Txt)] = ''%'') then Delete(Txt,Length(Txt),1);
    StrToFloat(Txt);
  except
    raise Exception.Create(''Invalid value'');
  end;
end;
procedure price_all_GetScript(spObject: TSPObject; var strValue: string);
var Txt: String;
begin
  strValue := '''';
  try
    Txt := trim(spObject.Values);
    if (Length(Txt) > 0) and (Txt[1] = ''='') then begin
      Delete(Txt,1,1);
      strValue := ''EQUAL'' + cnst_RANGE_DATA_DELIMETER + Txt;
      exit;
    end else
    if (Length(Txt) > 0) and (Txt[Length(Txt)] = ''%'') then begin
      Delete(Txt,Length(Txt),1);
      strValue := ''PERCENT'' + cnst_RANGE_DATA_DELIMETER + Txt;
      exit;
    end else
    strValue := ''ADDITION'' + cnst_RANGE_DATA_DELIMETER + Txt;
  except
  end;
end;
procedure price_all_RenderControl(strControlName: string; pControl: TControl; pHolder: TWinControl; pRectHolder: TRectHolder; var bDone: Boolean);
begin
  pControl.Top := pRectHolder.getTop - 1;
  pControl.Left := pRectHolder.getLeft - 1;
  pControl.Width := pRectHolder.getRight - pRectHolder.getLeft + 2;
  pHolder.InsertControl(pControl);
  pControl.OnExit := spExitControls;
  pControl.SetFocus;
  bDone := true;
end;
procedure price_all_GetVisibleData(spObject: TSPObject; KeyValue: String; var strValues: String);
begin
  if Pos(''.'',KeyValue) > 0 then
    strValues := Copy(KeyValue,1,Pos(''.'',KeyValue)-1) +
                 DecimalSeparator +
                 Copy(KeyValue,Pos(''.'',KeyValue)+1,Length(KeyValue))
  else strValues := KeyValue;
end;
procedure price_all_SetKChar(spObject: TSPObject; Ch: Char);
begin
  TEdit(spObject.getControl(''num'')).Text := Ch;
  TEdit(spObject.getControl(''num'')).SelStart := 1;
end;
procedure price_all_SynchronValues(spObject: TSPObject);
var tmpS: String;
begin
  try
    if Pos(DecimalSeparator,TEdit(spObject.getControl(''num'')).Text) > 0 then
      tmpS := Copy(TEdit(spObject.getControl(''num'')).Text,1,Pos(DecimalSeparator,TEdit(spObject.getControl(''num'')).Text)-1) +
              ''.''+
              Copy(TEdit(spObject.getControl(''num'')).Text,Pos(DecimalSeparator,TEdit(spObject.getControl(''num'')).Text)+1,Length(TEdit(spObject.getControl(''num'')).Text))
    else tmpS := TEdit(spObject.getControl(''num'')).Text;
    if (TmpS <> '''') then
      if (TmpS[1] <> ''='') and (TmpS[1] >= ''0'') and (TmpS[1] <= ''9'') then
        TmpS := ''+'' + TmpS;
    spObject.Values := TmpS;
  except
  end;
end;
procedure price_all_BeforeRender(spObject: TSPObject; pHplder: TWinControl);
begin
  spObject.releaseControls;
  spObject.addControl(''num'', TEdit.Create(spObject));
  TEdit(spObject.getControl(''num'')).OnKeyDown := spKeyDown;
  if Pos(''.'',spObject.Values) > 0 then
    TEdit(spObject.getControl(''num'')).Text := Copy(spObject.Values,1,Pos(''.'',spObject.Values)-1) +
                                              DecimalSeparator +
                                              Copy(spObject.Values,Pos(''.'',spObject.Values)+1,Length(spObject.Values))
  else TEdit(spObject.getControl(''num'')).Text := spObject.Values;
end;
end.'
WHERE  tp.INTERNAL_PARAM_NAME = 'price_all';


commit work;

