ALTER INDEX PD_FIRST_NAME_UTF_IDX INACTIVE;

ALTER INDEX PD_SURNAME_UTF_IDX INACTIVE;

ALTER INDEX PD_FAMILY_NAME_UTF_IDX INACTIVE;

ALTER INDEX PD_PERSON_NAME_IDX INACTIVE;

RECONNECT;

execute procedure SYSTEM_INFO_GET('DATABASE CHARSET');

update PERSON_DATA PD
set pd.FIRST_NAME_UTF = cast(pd.FIRST_NAME as varchar(200) character set win1250),
    pd.SURNAME_UTF = cast(pd.SURNAME as varchar(200) character set win1250),
    pd.FAMILY_NAME_UTF = cast(pd.FAMILY_NAME as varchar(200) character set win1250),
    pd.PERSON_NAME_UTF = cast(pd.PERSON_NAME as varchar(200) character set win1250)
where RDB$GET_CONTEXT('USER_SESSION', 'DATABASE CHARSET') = 'WIN1250';

update PERSON_DATA PD
set pd.FIRST_NAME_UTF = cast(pd.FIRST_NAME as varchar(200) character set win1251),
    pd.SURNAME_UTF = cast(pd.SURNAME as varchar(200) character set win1251),
    pd.FAMILY_NAME_UTF = cast(pd.FAMILY_NAME as varchar(200) character set win1251),
    pd.PERSON_NAME_UTF = cast(pd.PERSON_NAME as varchar(200) character set win1251)
where RDB$GET_CONTEXT('USER_SESSION', 'DATABASE CHARSET') = 'WIN1251';

update PERSON_DATA PD
set pd.FIRST_NAME_UTF = cast(pd.FIRST_NAME as varchar(200) character set win1252),
    pd.SURNAME_UTF = cast(pd.SURNAME as varchar(200) character set win1252),
    pd.FAMILY_NAME_UTF = cast(pd.FAMILY_NAME as varchar(200) character set win1252),
    pd.PERSON_NAME_UTF = cast(pd.PERSON_NAME as varchar(200) character set win1252)
where RDB$GET_CONTEXT('USER_SESSION', 'DATABASE CHARSET') = 'WIN1252';

commit work;

ALTER INDEX PD_FIRST_NAME_UTF_IDX ACTIVE;

ALTER INDEX PD_SURNAME_UTF_IDX ACTIVE;

ALTER INDEX PD_FAMILY_NAME_UTF_IDX ACTIVE;

ALTER INDEX PD_PERSON_NAME_IDX ACTIVE;

delete
from   agent a
where  not exists (select * from PROFILE_AGENT pa where pa.ID_AGENT = a.ID_AGENT);

commit work;
