select gen_id(GEN_TAR_UI_PARAMS, max(p.ID_TAR_PARAM) - gen_id(GEN_TAR_UI_PARAMS, 0))
from   TAR_UI_PARAMS p;
commit work;

select gen_id(ID_TARIFA_PARAM_GEN, max(p.ID_TARIFA_PARAM) - gen_id(ID_TARIFA_PARAM_GEN, 0))
from   TARIFA_PARAMS p;
commit work;

INSERT INTO TAR_UI_PARAMS (INTERNAL_PARAM_NAME, DELPHI_IMPLEMENT, IS_ACTIVE, IS_LIBRARY, IS_SYSTEM, ALIGN, DEFAULT_VALUE_INTERFACE, DEFAULT_VALUE_FORMULA, TAGS, TAG_DATA, INTERFACE_PARAMETER, IS_ALLOW_NEGATIVE) VALUES ('TO_AGENT', NULL, 1, 0, 0, 0, '', '', 'GUEST,AGENT', '', NULL, 0);
INSERT INTO TARIFA_PARAMS (PARAM_NAME, IS_INTERFACE, IS_DATE_DEPENDANT, PARAM_CODE, IS_USE, DATA_TYPE, IS_VALUE, PVALUE, CONTROL_TYPE, IS_FORMULA, FORMULA, PARAM_NOTE) VALUES ('/  ', 0, 1, 'TO_AGENT', 1, 'INTEGER', NULL, NULL, NULL, NULL, NULL, '/  ');

commit work;

update TAR_UI_PARAMS p
set p.DELPHI_IMPLEMENT =
'unit to_agent;
implementation
uses default_handlers;
procedure local_ValidateControls(spObject: TSPObject);
begin
end;
procedure local_GetScript(spObject: TSPObject; var strValue: string);
begin
  if TComboBox(spObject.getControl(''cb'')).ItemIndex = -1 then
    strValue := ''''
  else if TComboBox(spObject.getControl(''cb'')).ItemIndex = 1 then
    strValue := '':TO_AGENT <> '' + TRxDBLookupCombo(spObject.getControl(''lookupcb'')).value
  else if TComboBox(spObject.getControl(''cb'')).ItemIndex = 0 then
    strValue := '':TO_AGENT = '' + TRxDBLookupCombo(spObject.getControl(''lookupcb'')).value;
end;

procedure local_BeforeRender(spObject: TSPObject; pHplder: TWinControl);
var
  pDS: TDataSource;
begin
  pDS := spObject.getDataSource(''AGENT_PROFILES'', ''select P.ID_PROFILE, P.PROFILE_NAME from PROFILE P join PROFILE_AGENT PA on PA.ID_PROFILE = p.ID_PROFILE order by P.PROFILE_NAME'');
  spObject.releaseControls;
  spObject.addControl(''cb'', TComboBox.create(spObject));
  TComboBox(spObject.getControl(''cb'')).OnKeyDown := local_KeyDown;
  TComboBox(spObject.getControl(''cb'')).Style := csDropDownList;
  spObject.addControl(''lookupcb'', TRxDBLookupCombo.create(spObject));
  TRxDBLookupCombo(spObject.getControl(''lookupcb'')).DropDownWidth := 200;
  if nil <> pDS then begin
    TRxDBLookupCombo(spObject.getControl(''lookupcb'')).LookupSource := pDS;
    TRxDBLookupCombo(spObject.getControl(''lookupcb'')).LookupField := ''ID_PROFILE'';
    TRxDBLookupCombo(spObject.getControl(''lookupcb'')).LookupDisplay := ''PROFILE_NAME'';
    TRxDBLookupCombo(spObject.getControl(''lookupcb'')).OnKeyDown := local_KeyDown;
  end;
end;
procedure local_RenderControl(strControlName: string; pControl: TControl; pHolder: TWinControl; pRectHolder: TRectHolder; var bDone: Boolean);
begin
  pControl.Top := pRectHolder.getTop - 1;
  if strControlName = ''cb'' then pControl.left := pRectHolder.getLeft - 1
  else pControl.left := TSPObject(pControl.Owner).getControl(''cb'').left + TSPObject(pControl.Owner).getControl(''cb'').Width;
  if strControlName = ''cb'' then pControl.Width := 40
  else pControl.Width := (pRectHolder.getRight - pRectHolder.getLeft + 2) - TSPObject(pControl.Owner).getControl(''cb'').Width;
  pHolder.InsertControl(pControl);
  pControl.OnExit := spExitControls;
  if strControlName = ''cb'' then begin
    SetValues(TSPObject(pControl.OWner));
    pControl.SetFocus;
  end;
  bDone := true;
end;
procedure SetValues(spObject: TSPObject);
var Part1: String;
    tmpS, strValues: String;
begin
  strValues := spObject.values;
  tmpS := strValues;
  if (tmpS <> '''') then
    if (tmpS[1] = ''='') then begin
      Part1 := tmpS[1];
      delete(tmpS,1,1);
    end else begin
      if (tmpS[1] = ''<'') then begin
        Part1 := Copy(tmpS,1,2);
        delete(tmpS,1,2);
      end;
    end;
  TComboBox(spObject.getControl(''cb'')).Items.Clear;
  TComboBox(spObject.getControl(''cb'')).Items.add(''='');
  TComboBox(spObject.getControl(''cb'')).Items.add(''<>'');
  TComboBox(spObject.getControl(''cb'')).ItemIndex := TComboBox(spObject.getControl(''cb'')).Items.IndexOf(Part1);
  if Pos('';'',tmpS) > 0 then
    tmpS := Copy(tmpS,1,Pos('';'',tmpS)-1);
  TRxDBLookupCombo(spObject.getControl(''lookupcb'')).value := tmpS;
end;
procedure local_SynchronValues(spObject: TSPObject);
begin
  try
    spObject.values := TComboBox(spObject.getControl(''cb'')).Text +
                       TRxDBLookupCombo(spObject.getControl(''lookupcb'')).value + '';'' +
                       TRxDBLookupCombo(spObject.getControl(''lookupcb'')).Text;
  except
  end;
end;
procedure local_SetKChar(spObject: TSPObject; Ch: char);
begin
  if Ch = ''='' then begin
    TComboBox(spObject.getControl(''cb'')).ItemIndex := TComboBox(spObject.getControl(''cb'')).Items.IndexOf(Ch);
    TRxDBLookupCombo(spObject.getControl(''lookupcb'')).SetFocus;
  end else if Ch = ''<'' then begin
    TComboBox(spObject.getControl(''cb'')).ItemIndex := TComboBox(spObject.getControl(''cb'')).Items.IndexOf(''<>'');
    TRxDBLookupCombo(spObject.getControl(''lookupcb'')).SetFocus;
  end;
end;
procedure local_KeyDown(Sender: TObject; var key: Word;
  Shift: TShiftState);
begin
  if (Shift = []) and (key = 13) then
    if TControl(Sender).Owner <> nil then
      if Sender = TSPObject(TControl(Sender).Owner).getControl(''cb'') then
        if not TComboBox(Sender).DroppedDown then
          TSPObject(TControl(Sender).Owner).getControl(''lookupcb'').SetFocus
        else
      else if not TRxDBLookupCombo(Sender).IsDropDown then
             TControl(Sender).Parent.SetFocus
           else
    else
  else if (Shift = []) and (key = 27) then
    if TControl(Sender).Owner <> nil then begin
      TSPObject(TControl(Sender).Owner).CancelGetValues := True;
      TControl(Sender).Parent.SetFocus;
    end;
end;
procedure local_GetVisibleData(spObject: TSPObject; KeyValue: String; var strValues: String);
begin
  if KeyValue <> '''' then
    if (KeyValue[1] = ''='') then begin
      strValues := KeyValue[1];
      delete(KeyValue,1,1);
    end else if (KeyValue[1] = ''<'') then begin
      strValues := ''<>'';
      delete(KeyValue,1,2);
    end else strValues := ''''
  else strValues := '''';
  if Pos('';'',KeyValue) > 0 then
    strValues := strValues + Copy(KeyValue,Pos('';'',KeyValue)+1,length(KeyValue));
end;

function expandGUID(spObject: TSPObject): String;
var key: String;
begin
  key := TRxDBLookupCombo(spObject.getControl(''lookupcb'')).Value;
  if StrToIntDef(key,0) > 0 then
    key := ''@{AGENT_PROFILES.'' + key + '';'' + TRxDBLookupCombo(spObject.getControl(''lookupcb'')).Text + ''}'';
  Result := key;
end;

procedure localGetInterfaceValuesUID(spObject: TSPObject; var strValues: string);
begin
  try
    strValues := TComboBox(spObject.getControl(''cb'')).Text + expandGUID(spObject) + '';'' + TRxDBLookupCombo(spObject.getControl(''lookupcb'')).Text;
  except
  end;
end;

procedure localGetScriptUID(spObject: TSPObject; var strValue: string);
begin
  if TComboBox(spObject.getControl(''cb'')).ItemIndex = -1 then
    strValue := ''''
  else if TComboBox(spObject.getControl(''cb'')).ItemIndex = 1 then
    strValue := '':TO_AGENT <> '' + expandGUID(spObject)
  else if TComboBox(spObject.getControl(''cb'')).ItemIndex = 0 then
    strValue := '':TO_AGENT = '' + expandGUID(spObject);
end;
function main: TSPObject;
begin
  Result := TSPObject.create(nil);
  Result.OnGetInterfaceValues := spGetInterfaceValues;
  Result.OnSetInterfaceValues := spSetInterfaceValues;
  Result.OnGetScript := local_GetScript;
  Result.OnRenderControl := local_RenderControl;
  Result.BeforeRender := local_BeforeRender;
  Result.OnValidateControls := local_ValidateControls;
  Result.OnSynchronValues := local_SynchronValues;
  Result.BeforeRemoveControls := spBeforeRemoveControls;
  Result.OnSetKChar := local_SetKChar;
  Result.OnGetVisibleData := local_GetVisibleData;
  Result.OnGetInterfaceValuesUID := localGetInterfaceValuesUID;
  Result.OnGetScriptUID := localGetScriptUID;
end;
end.'
where  p.INTERNAL_PARAM_NAME = 'TO_AGENT';

commit work;
