update GUEST g
set    g.ID_HOTEL = (select rd.ID_HOTEL
                     from   RESERV_DETAIL rd
                     where  rd.ID_RESERV_DETAIL = g.ID_RESERV_DETAIL),
       g.CHECKED_IN_AT = iif(g.IS_CHECK_IN = 1,
                             coalesce((select first 1 sl.ACTION_DATETIME
                             from   SYSTEM_LOG_RESERV lr
                                    join SYSTEM_LOG sl on sl.ID_SYSTEM_LOG = lr.ID_SYSTEM_LOG
                             where  lr.ID_RESERV_DETAIL = g.ID_RESERV_DETAIL and sl.ACTION_CODE = 'CHECK_IN'),
                             cast(g.FROM_DATE as timestamp)),
                             null);

commit work;

