
update DOC_HEAD$INT d
set    d.DOC_TYPE_NAME = (select iif(trim(d.DOC_TYPE_NAME) = dt.DOC_TYPE_NAME, dt.DOC_TYPE_NAME, d.DOC_TYPE_NAME)
                          from   DOC_TYPE dt
                          where  dt.ID_DOC_TYPE = d.ID_DOC_TYPE)
where  d.DOC_TYPE_NAME starting with ' ';

commit work;

update DEPOSIT d
set    d.ID_BILLING_SERVICE = (select dl.ID_SERVICE
                               from   PAYMENT_HEAD p
                                      join DOC_HEAD$INT dh on dh.ID_DOC_HEAD = p.ID_DOC_HEAD
                                      join doc_line dl on dl.ID_DOC_HEAD = dh.ID_DOC_HEAD
                                      join DOC_LINE_DEP_VALUES dv on dv.ID_DOC_LINE = dl.ID_DOC_LINE
                               where  p.ID_PAYMENT_HEAD = d.ID_PAYMENT_HEAD
                                      and dh.IS_ANUL = 0
                                      and dv.ID_DEPOSIT = d.ID_DEPOSIT);
commit work;

update PROFILE p
set    p.BONUSPOINT_GAINED = (select pw.TOTAL_POINTS_GAINED
                              from   PROFILE_WALLET pw
                              where  pw.ID_PROFILE = p.ID_PROFILE),
       p.BONUSPOINT_CONSUMED = (select pw.TOTAL_POINTS_CONSUMED
                              from   PROFILE_WALLET pw
                              where  pw.ID_PROFILE = p.ID_PROFILE);

commit work;

update PMS_EVENT$PMS pe
set    pe.ID_ROOM_CONTRACT = (select rc.ID_ROOM_CONTRACT
                              from   ROOM_PERIOD$PMS rp
                                     join ROOM_CONTRACT$PMS rc on rc.ID_ROOM_PERIOD = rp.ID_ROOM_PERIOD
                              where  rp.ID_ROOM = pe.ID_ROOM
                                     and rp.FROM_DATE <= coalesce(pe.MANUAL_POST_DATE, pe.IMP_PERIOD_FROM)
                                     and rp.TO_DATE >= coalesce(pe.MANUAL_POST_DATE, pe.IMP_PERIOD_TO))
where  pe.ID_ROOM_CONTRACT is null;

commit work;

