SET TERM ^ ;

CREATE OR ALTER trigger PROFILE_BIU0 for PROFILE
active before insert or update position 5
AS
  declare variable charset varchar(20);
begin
  if ((inserting) or (new.PROFILE_NAME is distinct from old.PROFILE_NAME) ) then begin
    select si.INFO_VALUE
    from   SYSTEM_INFO_GET('DATABASE CHARSET') si
    into   :charset;

    if (:charset = 'WIN1250') then new.MERGE_NAME = cast(new.PROFILE_NAME as varchar(200) character set win1250);
    else if (:charset = 'WIN1251') then new.MERGE_NAME = cast(new.PROFILE_NAME as varchar(200) character set win1251);
    else if (:charset = 'WIN1252') then new.MERGE_NAME = cast(new.PROFILE_NAME as varchar(200) character set win1252);
    else new.MERGE_NAME = cast(new.PROFILE_NAME as varchar(200) character set win1252);

  end
end^

SET TERM ; ^

commit work;

