update doc_line dl
set    dl.NAT_GROSS_VALUE = (select dl.QTY_POST * dl.SINGLE_VALUE * d.DOC_RATE
                             from   DOC_HEAD d
                             where  d.ID_DOC = dl.ID_DOC_HEAD),
       dl.NAT_NET_VALUE = (select tv.VALUE_WOT_TAX
                           from   TAX_VALUE_DEDUCT (dl.NAT_GROSS_VALUE, 0.01, dl.ID_SALE_TAXATION) tv)
where  dl.WOT_DIFF <> 0
       and dl.NAT_GROSS_VALUE = 0;


update doc_line dl
set    dl.SEC_CURR_GROSS_VALUE = (select dl.QTY_POST * dl.SINGLE_VALUE * cast(d.DOC_RATE / d.SECOND_CURR_RATE as double precision)
                             from   DOC_HEAD d
                             where  d.ID_DOC = dl.ID_DOC_HEAD),
       dl.SEC_CURR_NET_VALUE = (select tv.VALUE_WOT_TAX
                           from   TAX_VALUE_DEDUCT (dl.SEC_CURR_GROSS_VALUE, 0.01, dl.ID_SALE_TAXATION) tv)
where  dl.WOT_DIFF <> 0
       and dl.SEC_CURR_GROSS_VALUE = 0
       and exists (select d.ID_DOC
                   from   DOC_HEAD d
                   where  d.ID_DOC = dl.ID_DOC_HEAD
                          and d.SECOND_CURRENCY is not null);




