/* Server version: WI-V6.3.4.18393 Firebird 2.1 
   SQLDialect: 3. ODS: 11.1. Forced writes: On. Sweep inteval: 20000.
   Page size: 8192. Cache pages: 2048 (16384 Kb). Read-only: False. */

SET SQL DIALECT 3;

SET TERM ^ ;

/* Alter (TAR_BO_PRICE_GET) */
ALTER PROCEDURE TAR_BO_PRICE_GET(ID_TAR_BO_PRICE ID)
 RETURNS(PRICE_VALUE TYPE OF TTEXT_FORMULA,
PRICE_TYPE TYPE OF NAME_20)
 AS
begin
  PRICE_VALUE = null;
  select p.PRICE_TYPE, p.PRICE_VALUE
  from   TAR_BO_PRICES p
  where  p.ID_TAR_BO_PRICE = :ID_TAR_BO_PRICE
  into   :PRICE_TYPE, :PRICE_VALUE;

  if (:PRICE_TYPE <> 'FORMULA') then begin
    PRICE_VALUE = cast(:PRICE_VALUE as TPRICE);

    when any do exception RATING_EXCEPTION '-62' || f_character(31) || f_character(29) || coalesce(:PRICE_VALUE, '');
  end

  if (:PRICE_VALUE is not null) then suspend;
end
^

SET TERM ; ^

commit work;

