
update ROOM_MAGIC rm
set    rm.ROOM_STATUS = (select  rp.STATUS
                        from    ROOM_PERIOD$PMS rp
                        where   rp.ID_ROOM = rm.ID_ROOM$INT
                                and rp.FROM_DATE <= rm.BUSY_DATE
                                and rp.TO_DATE >= rm.BUSY_DATE)
where  rm.ROOM_STATUS is null
       and rm.ID_ROOM$INT is not null;

commit work;


update RESERV_DETAIL rd
set    rd.CHECK_OUT_KIND = coalesce((select first 1
                                            case
                                              when sl.ACTION_CODE = 'CHECK_OUT_EARLY1' then 1
                                              when sl.ACTION_CODE = 'CHECK_OUT_EARLY2' then 2
                                              when sl.ACTION_CODE = 'CHECK_OUT_EARLY3' then 3
                                              else 0
                                            end
                                     from   SYSTEM_LOG_EVENT sl
                                     where  sl.ACTION_CODE starting with 'CHECK_OUT'
                                            and sl.LOG_OBJECT_CLASS = 'GUEST'
                                            and sl.LOG_OBJECT_ID = rd.ID_TITULAR), 0),
       rd.EARLYCHECKOUT_DATE = (select g.EARLYCHECKOUT_DATE
                                from   GUEST g
                                where  g.ID_GUEST = rd.ID_TITULAR)
where  rd.CHECK_STATUS > 0;

commit work;


