delete from PRODUCT_LICENSE;

commit work;


INSERT INTO SETTING (SETTING_CODE, DEF_DESCRIPTION, CONTROL_CLASS, ID_SETTING_GRP)
select 'DEF_BASE_SERVICE_GROUP',
       '       (   ).',
       'LOOKUP',
       g.ID_SETTING_GRP
from   SETTING g
where  g.SETTING_CODE = 'DEF_PAY_TYPE';

commit work;

select gen_id(GEN_SETTING_ITEM_ID, max(i.ID_SETTING_ITEM) - gen_id(GEN_SETTING_ITEM_ID, 0))
from   SETTING_ITEM i;

commit work;

INSERT INTO SETTING_ITEM (SETTING_CODE, SET_ITEM_VALUE, SET_ITEM_CODE, LOOKUP_SQL, GET_RECORD_FKEY_TYPE, GET_RECORD_SQL)
VALUES ('DEF_BASE_SERVICE_GROUP', NULL, NULL, 'select SG.ID_SERVICE_GROUP, SG.GROUP_NAME from SERVICE_GROUPS SG where sg.id_hotel = :id_hotel order by 2', 'integer', 'select SG.ID_SERVICE_GROUP, SG.GROUP_NAME from SERVICE_GROUPS SG where SG.ID_SERVICE_GROUP = :fkey and sg.id_hotel = :id_hotel');

commit work;

select gen_id(GEN_WIZARD_ITEM_ID, max(i.ID_WIZARD_ITEM) - gen_id(GEN_WIZARD_ITEM_ID, 0))
from   WIZARD_ITEM i;

commit work;

INSERT INTO WIZARD_ITEM (ITEM_KEY, ITEM_NAME, ID_GROUP, ITEM_POS, REQUIRED_ITEMS, KEY_WORDS, VALIDATE_SQL, HELP_URL)
VALUES ('setting.DEF_BASE_SERVICE_GROUP', '       (   ).', 12, 42, NULL, ',', NULL, 'http://www.clock-hotel-software.com/@{lang}/help-wizard-article/article/help-wizard-setting-def-base-service-group/?no_cache=1');

commit work;

