set term ^;

create procedure remake_profile_person_tags
as
  declare variable id_profile integer;
  declare variable dbkey char(8);
begin
  for
    select pp.ID_PROFILE, st.RDB$DB_KEY
    from   PROFILE_PERSON pp
           join PROFILE_SEARCH_TAG st on st.ID_PERSON_DATA = pp.ID_PERSON_DATA
    where  st.TAG_NAME in ('NAME', 'NAME2', 'EGN', 'PASS_NUM') and st.ID_PROFILE is null
    into   :id_profile, :dbkey
  do begin
    update PROFILE_SEARCH_TAG t
    set    t.ID_PROFILE = :id_profile
    where  t.RDB$DB_KEY = :dbkey;
  end 
end
^

set term ;^

execute procedure REMAKE_PROFILE_PERSON_TAGS;

commit work;

drop procedure REMAKE_PROFILE_PERSON_TAGS;

commit work;

