set term ^;

create procedure TMP_UPDATE_CANCELATION_DATE
as
  declare variable no_use varchar(255) ;
begin
  select RDB$SET_CONTEXT('USER_TRANSACTION', 'DISABLE_SUMMARY_REBUILD','1')
  from   dummy
  into   :no_use;

  update RESERV_DETAIL rd
  set    rd.CANCELATION_DATE = (select first 1 cast(sl.ACTION_DATETIME as date)
                                from   SYSTEM_LOG sl
                                       join SYSTEM_LOG_RESERV slr on slr.ID_SYSTEM_LOG = sl.ID_SYSTEM_LOG
                                where  slr.ID_RESERV_DETAIL = rd.ID_RESERV_DETAIL
                                       and sl.LOG_OBJECT_CLASS = 'RES_DETAIL'
                                       and sl.ACTION_CODE = 'RES_ANUL')
  where  rd.IS_ANUL = 1
         and rd.CANCELATION_DATE is null;
end
^

set term ;^

execute procedure TMP_UPDATE_CANCELATION_DATE;

commit work;

drop procedure TMP_UPDATE_CANCELATION_DATE;

commit work;

INSERT INTO EAI_EVENTQ_PUBLISH (ACTION_CODE) VALUES ('RES_MOD_PERIOD');

commit work;

