SET BLOBFILE '__binary__.lob';
update dummy
set    b = (select gen_id(GEN_SYSTEM_INFO_UPDATE_ID, max(su.ID_INFO_UPDATE) - gen_id(GEN_SYSTEM_INFO_UPDATE_ID, 0))
            from   SYSTEM_INFO_UPDATE su);
/* syncronize generator to actual value */

update SYSTEM_INFO_UPDATE su
set    su.BIN_CONTENT = null;  -- delete the old client updates

commit work;

insert into SYSTEM_INFO_UPDATE
  (PRODUCT_VERSION, PATCH_VERSION,DATETIME_EXECUTION,BIN_CONTENT, RELEASE_DATE)
values
  ('EVO-2011', '61', current_timestamp, :h0C4BB2_255FAF7 , '04.06.2021');

insert into SYSTEM_INFO_MODULE
  (ID_INFO_UPDATE,APP_MODULE_NAME,APP_MODULE_VERSION)
select max(SIU.ID_INFO_UPDATE),
       'EVOLUTION',
       '9.0.0.61'
from SYSTEM_INFO_UPDATE SIU;

insert into SYSTEM_INFO_MODULE
       (ID_INFO_UPDATE,APP_MODULE_NAME,APP_MODULE_VERSION)
select max(SIU.ID_INFO_UPDATE),
       'DBMAIN',
       '61'
from SYSTEM_INFO_UPDATE SIU;
commit work;

delete from SYSTEM_UPDATE_NOTIFICATION;
commit work;

execute procedure SYSTEM_INFO_SET('PATCH_VERSION', '61');
commit work;

execute procedure RIGHTS_REGRANT;
commit work;

/* release export log, after all db updates */
update SYSTEM_INFO si
set    si.INFO_VALUE = f_replstr(si.INFO_VALUE, '_', '')
where  si.INFO_KEY = 'EXPORT_LOG';

commit work;
